| C prototype: void GrayClipSprite16_SHADOW2_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),register unsigned short blitmask asm("%d3"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__regparm__(6)));

.data
.globl GrayClipSprite16_SHADOW2_R
.even

GrayClipSprite16_SHADOW2_R:
    movem.l  %d3-%d5,-(%sp)

    moveq    #-1,%d4
    and.w    %d3,%d4

    subq.w   #1,%d2  | %d2 = h - 1
    move.w   %d1,%d3  | %d3 = y
    bpl.s    __YPositive_GrayClipSprite16_SHADOW2_R | h > 0 ?

    add.w    %d1,%d2  | %d2 = h + y
    bmi.s    __End_GrayClipSprite16_SHADOW2_R  | y + h < 0 ?

    moveq.l  #0,%d1  | offsety = 0
    bra.s    __ClipX_GrayClipSprite16_SHADOW2_R

__YPositive_GrayClipSprite16_SHADOW2_R:
    subi.w   #127,%d3  | %d3 = y - 127
    bhi.s    __End_GrayClipSprite16_SHADOW2_R  | y - 127 >= 0 ?

    add.w    %d2,%d3  | %d3 = h + y - 128
    bmi.s    __CalcOffset_GrayClipSprite16_SHADOW2_R | h + y - 128 < 0 ?

    sub.w    %d3,%d2  | h -= h + y -128 (h = y - 128)

__CalcOffset_GrayClipSprite16_SHADOW2_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1  | %d1 = y*15

__ClipX_GrayClipSprite16_SHADOW2_R:
    move.w   %d0,%d3  | %d3 = x
    bmi.s    __ClipXLeft_GrayClipSprite16_SHADOW2_R | x < 0 ?

    cmpi.w   #239-16,%d0
    jbhi     __ClipXRight_GrayClipSprite16_SHADOW2_R | x > 239-15

    lsr.w    #4,%d3  | %d3 = x/16
    add.w    %d3,%d1  | %d3 = x/16 + y*15
    add.w    %d1,%d1  | %d3 = x/8 + y*30
    adda.w   %d1,%a0  | dest += offset
    adda.w   %d1,%a1

    andi.w   #0xF,%d0
    moveq    #16,%d1
    sub.w    %d0,%d1

    rol.l    %d1,%d4
    move.l   %d4,%d5
    not.l    %d5

__loop_GrayClipSprite16_SHADOW2_R_:
    move.l   (%a0),%d0
    move.l   (%a1),%d1

    move.l   %d0,%d3
    not.l    %d3
    or.l     %d1,%d3
    or.l     %d0,%d1

    and.l    %d4,(%a0)
    and.l    %d4,(%a1)
    and.l    %d5,%d3
    and.l    %d5,%d1

    or.l     %d3,(%a0)
    or.l     %d1,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,__loop_GrayClipSprite16_SHADOW2_R_

__End_GrayClipSprite16_SHADOW2_R:
    movem.l  (%sp)+,%d3-%d5
    rts

/*
    move.l   %d4,%d5
    not.l    %d5

_loop_GrayClipSprite16_SHADOW2_R_1:
    move.l   (%a0),%d0
    move.l   (%a1),%d1

    move.l   %d0,%d3
    not.l    %d3
    or.l     %d1,%d3
    or.l     %d0,%d1

    and.l    %d4,(%a0)
    and.l    %d4,(%a1)
    and.l    %d5,%d3
    and.l    %d5,%d1

    or.l     %d3,(%a0)
    or.l     %d1,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,_loop_GrayClipSprite16_SHADOW2_R_1

__End_GrayClipSprite16_SHADOW2_R:
    movem.l  (%sp)+,%d3-%d5/%a2
    rts
*/
__ClipXLeft_GrayClipSprite16_SHADOW2_R:
    cmpi.w   #-16,%d0
    bls.s    __End_GrayClipSprite16_SHADOW2_R  | x <= -16 ?

    neg.w    %d0  | shift = -x
    add.w    %d1,%d1  | %d1 = y*30
    adda.w   %d1,%a0  | dest += offset
    adda.w   %d1,%a1

    rol.l    %d0,%d4

__LoopsClip_GrayClipSprite16_SHADOW2_R:
    move.w   %d4,%d5
    not.w    %d5

__LoopClipL_GrayClipSprite16_SHADOW2_R:
    move.w   (%a0),%d0
    move.w   (%a1),%d1

    move.w   %d0,%d3
    not.w    %d3
    or.w     %d1,%d3
    or.w     %d0,%d1
   
    and.w    %d4,(%a0)
    and.w    %d4,(%a1)
    and.w    %d5,%d3
    and.w    %d5,%d1

    or.w     %d3,(%a0)
    or.w     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1

    dbf      %d2,__LoopClipL_GrayClipSprite16_SHADOW2_R

    movem.l  (%sp)+,%d3-%d5
    rts


__ClipXRight_GrayClipSprite16_SHADOW2_R:
    cmpi.w   #239,%d0
    bhi.s    __End_GrayClipSprite16_SHADOW2_R  | x > 239

    andi.w   #15,%d0  | shiftx = x & 15

    add.w    %d1,%d1  | %d1 = y*30
    addi.w   #28,%d1  | On va au bout de la ligne
    adda.w   %d1,%a0  | dest += offset
    adda.w   %d1,%a1

    ror.l    %d0,%d4

    bra.s    __LoopsClip_GrayClipSprite16_SHADOW2_R
