| C prototype: void GraySprite16_ISHADOW_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),register unsigned short blitmask asm("%d3"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__regparm__(6)));
|
| Reciprocal of GraySprite16_SHADOW_R, made by Lionel Debroux.

.data
.globl GraySprite16_ISHADOW_R
.even

GraySprite16_ISHADOW_R:
    dbf      %d2,__rest_of_GraySprite16_ISHADOW_R__
    rts

__rest_of_GraySprite16_ISHADOW_R__:
    movem.l  %d3-%d4/%a2,-(%sp)

    move.l   4+12(%sp),%a2

    move.w   %d1,%d4 | d4 = y
    lsl.w    #4,%d1 | d1 = 16*y
    sub.w    %d4,%d1 | d1 = 15*y

    move.w   %d0,%d4 | d4 = x
    lsr.w    #4,%d4 | d4 = x/16

    add.w    %d4,%d1 | d1 = 15*y + x/16
    add.w    %d1,%d1 | d1 = 30*y + x/8
    adda.w   %d1,%a0 | a0 += offset
    adda.w   %d1,%a1 | a1 += offset

    andi.w   #0xF,%d0
    cmpi.w   #8,%d0
    bgt.s    _loop_GraySprite16_ISHADOW_R_2
    
_loop_GraySprite16_ISHADOW_R_1:
    move.l   (%a0),%d1
    move.l   (%a1),%d4

    move.l   %d1,%d3
    and.l    %d4,%d3
    not.l    %d1
    and.l    %d1,%d4

    moveq.l  #-1,%d1
    move.w   (%a2)+,%d1
    swap     %d1
    ror.l    %d0,%d1
    and.l    %d1,(%a0)
    and.l    %d1,(%a1)
    not.l    %d1
    and.l    %d1,%d3
    and.l    %d1,%d4
    
    or.l     %d4,(%a0)
    or.l     %d3,(%a1)
    
    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,_loop_GraySprite16_ISHADOW_R_1
    movem.l  (%sp)+,%d3-%d4/%a2
    rts

_loop_GraySprite16_ISHADOW_R_2:
    moveq    #16,%d1
    sub.w    %d0,%d1

__loop_GraySprite16_ISHADOW_R_2:
    move.l   (%a0),%d0
    move.l   (%a1),%d4

    move.l   %d0,%d3
    and.l    %d4,%d3
    not.l    %d0
    and.l    %d0,%d4

    moveq.l  #-1,%d0
    move.w   (%a2)+,%d0
    rol.l    %d1,%d0
    and.l    %d0,(%a0)
    and.l    %d0,(%a1)
    not.l    %d0
    and.l    %d0,%d3
    and.l    %d0,%d4
    
    or.l     %d4,(%a0)
    or.l     %d3,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,__loop_GraySprite16_ISHADOW_R_2

    movem.l  (%sp)+,%d3-%d4/%a2
    rts
