| C prototype: void GraySprite8_ISHADOW2_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),register unsigned char blitmask asm("%d3"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
|
| Derived from GraySprite8_ISHADOW_R to take a blitmask applied to all lines
| instead of a complete mask. This enables speeding up ISHADOW by at least
| one third, this is interesting since ISHADOW is among the most complex and
| therefore slowest drawing modes.

.data
.globl GraySprite8_ISHADOW2_R
.even

GraySprite8_ISHADOW2_R:
   dbf      %d2,__rest_of_GraySprite8_ISHADOW2_R__
   rts

__rest_of_GraySprite8_ISHADOW2_R__:
    movem.l  %d3-%d5,-(%sp)

    move.w   %d1,%d4 | d4 = y
    lsl.w    #4,%d1 | d1 = 16*y
    sub.w    %d4,%d1 | d1 = 15*y

    move.w   %d0,%d4 | d4 = x
    lsr.w    #4,%d4 | d4 = x/16

    add.w    %d4,%d1 | d1 = 15*y + x/16
    add.w    %d1,%d1 | d1 = 30*y + x/8
    adda.w   %d1,%a0 | a0 += offset
    adda.w   %d1,%a1 | a1 += offset

    moveq    #-1,%d4
    and.b    %d3,%d4

    andi.w   #0xF,%d0
    moveq    #8,%d1
    sub.w    %d0,%d1
    bge.s    _loop2_GraySprite8_ISHADOW2_R_

    neg.w    %d1
    swap     %d4
    ror.l    %d1,%d4
    move.l   %d4,%d5
    not.l    %d5

__loop1_GraySprite8_ISHADOW2_R_:
    move.l   (%a0),%d0
    move.l   (%a1),%d1

    move.l   %d0,%d3
    and.l    %d1,%d3
    not.l    %d0
    and.l    %d0,%d1

    and.l    %d5,%d1
    and.l    %d5,%d3

    and.l    %d4,(%a0)
    or.l     %d1,(%a0)

    and.l    %d4,(%a1)
    or.l     %d3,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,__loop1_GraySprite8_ISHADOW2_R_
    movem.l  (%sp)+,%d3-%d5
    rts


_loop2_GraySprite8_ISHADOW2_R_:
    rol.w    %d1,%d4
    move.w   %d4,%d5
    not.w    %d5

__loop2_GraySprite8_ISHADOW2_R_:
    move.w   (%a0),%d0
    move.w   (%a1),%d1

    move.w   %d0,%d3
    and.w    %d1,%d3
    not.w    %d0
    and.w    %d0,%d1

    and.w    %d5,%d1
    and.w    %d5,%d3

    and.w    %d4,(%a0)
    or.w     %d1,(%a0)

    and.w    %d4,(%a1)
    or.w     %d3,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,__loop2_GraySprite8_ISHADOW2_R_
    movem.l  (%sp)+,%d3-%d5
    rts
