| C prototype: void GraySprite8_SHADOW_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned char *mask,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
|
| Original routine by geogeo (Geoffrey Anneheim), modified to reduce size
| and take non-interlaced sprites by Lionel Debroux.

.data
.globl GraySprite8_SHADOW_R
.even

GraySprite8_SHADOW_R:
    dbf      %d2,__rest_of_GraySprite8_SHADOW_R__
    rts

__rest_of_GraySprite8_SHADOW_R__:
    movem.l  %d3-%d4/%a2,-(%sp)

    move.l   4+12(%sp),%a2

    move.w   %d1,%d3	| d3 = y
    lsl.w    #4,%d1	| d1 = 16*y
    sub.w    %d3,%d1	| d1 = 15*y

    move.w   %d0,%d3	| d3 = x
    lsr.w    #4,%d3	| d3 = x/16

    add.w    %d3,%d1	| d1 = 15*y + x/16
    add.w    %d1,%d1	| d1 = 30*y + x/8
    adda.w   %d1,%a0	| a0 += offset
    adda.w   %d1,%a1	| a1 += offset

    andi.w   #0xF,%d0
    moveq    #8,%d1
    sub.w    %d0,%d1
    bgt.s    __loop_GraySprite8_SHADOW_R_2

    neg.w    %d1
_loop_GraySprite8_SHADOW_R_1:
    move.l   (%a0),%d0
    move.l   (%a1),%d4

    move.l   %d0,%d3
    not.l    %d3
    or.l     %d4,%d3
    or.l     %d0,%d4
    
    moveq.l  #-1,%d0
    move.b   (%a2)+,%d0
    swap     %d0
    ror.l    %d1,%d0
    and.l    %d0,(%a0)
    and.l    %d0,(%a1)
    not.l    %d0
    and.l    %d0,%d3
    and.l    %d0,%d4
    
    or.l     %d3,(%a0)
    or.l     %d4,(%a1)
    
    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,_loop_GraySprite8_SHADOW_R_1
    movem.l  (%sp)+,%d3-%d4/%a2
    rts

_loop_GraySprite8_SHADOW_R_2:
    lea      30(%a0),%a0
    lea      30(%a1),%a1

__loop_GraySprite8_SHADOW_R_2:
    move.w   (%a0),%d0
    move.w   (%a1),%d4
    
    move.w   %d0,%d3
    not.w    %d3
    or.w     %d4,%d3
    or.w     %d0,%d4

    moveq.l  #-1,%d0
    move.b   (%a2)+,%d0
    rol.w    %d1,%d0
    and.w    %d0,(%a0)
    and.w    %d0,(%a1)
    not.w    %d0
    and.w    %d0,%d3
    and.w    %d0,%d4
    
    or.w     %d3,(%a0)
    or.w     %d4,(%a1)
    
    dbf      %d2,_loop_GraySprite8_SHADOW_R_2
    movem.l  (%sp)+,%d3-%d4/%a2
    rts
