| C prototype: void GrayClipSprite16_TRANB_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned short *sprt0,unsigned short *sprt1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));

.data
.globl GrayClipSprite16_TRANB_R
.even

GrayClipSprite16_TRANB_R:
    movem.l  %d3-%d5/%a2-%a3,-(%sp)

    move.l   4+20(%sp),%a2
    move.l   4+20+4(%sp),%a3
    
    moveq.l  #-1,%d5
    clr.w    %d5

    subq.w   #1,%d2		| %d2 = h - 1

    move.w   %d1,%d3		| %d3 = y
    bpl.s    __YPositive_GrayClipSprite16_TRANB_R	| h > 0 ?

    add.w    %d1,%d2		| %d2 = h + y
    bmi.s    __End_GrayClipSprite16_TRANB_R		| y + h < 0 ?

    add.w    %d1,%d1		| %d1 = 2y
    suba.w   %d1,%a2		| sprt -= 2y
    suba.w   %d1,%a3

    moveq.l  #0,%d1		| offsety = 0
    bra.s    __ClipX_GrayClipSprite16_TRANB_R

__YPositive_GrayClipSprite16_TRANB_R:
    subi.w   #127,%d3		| %d3 = y - 127
    bhi.s    __End_GrayClipSprite16_TRANB_R		| y - 127 >= 0 ?

    add.w    %d2,%d3		| %d3 = h + y - 127
    bmi.s    __CalcOffset_GrayClipSprite16_TRANB_R	| h + y - 127 < 0 ?

    sub.w    %d3,%d2		| h -= h + y -128 (h = y - 127)

__CalcOffset_GrayClipSprite16_TRANB_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1		| %d1 = y*15

__ClipX_GrayClipSprite16_TRANB_R:
    move.w   %d0,%d3		| %d3 = x
    bmi.s    __ClipXLeft_GrayClipSprite16_TRANB_R	| x < 0 ?

    cmpi.w   #239-16,%d0
    bhi.w    __ClipXRight_GrayClipSprite16_TRANB_R	| x > 239-15

    lsr.w    #4,%d3		| %d3 = x/16
    add.w    %d3,%d1		| %d3 = x/16 + y*15
    add.w    %d1,%d1		| %d3 = x/8 + y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

    andi.w   #15,%d0
    moveq.l  #16,%d1
    sub.w    %d0,%d1

    rol.l    %d1,%d5

__Loop_GrayClipSprite16_TRANB_R:
    moveq.l  #0,%d0
    move.w   (%a2)+,%d0
    lsl.l    %d1,%d0

    moveq.l  #0,%d3
    move.w   (%a3)+,%d3
    lsl.l    %d1,%d3

    move.l   %d3,%d4
    and.l    %d0,%d4
    or.l     %d5,%d4

    and.l    %d4,(%a0)
    and.l    %d4,(%a1)

    not.l    %d4
    and.l    %d4,%d0
    and.l    %d4,%d3

    or.l     %d0,(%a0)
    or.l     %d3,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1

    dbf      %d2,__Loop_GrayClipSprite16_TRANB_R

__End_GrayClipSprite16_TRANB_R:
    movem.l  (%sp)+,%d3-%d5/%a2-%a3
    rts

__ClipXLeft_GrayClipSprite16_TRANB_R:
    cmpi.w   #-16,%d0
    bls.s    __End_GrayClipSprite16_TRANB_R		| x <= -16 ?

    neg.w    %d0		| shift = -x

    add.w    %d1,%d1		| %d1 = y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

    rol.l    %d0,%d5

__LoopClipL_GrayClipSprite16_TRANB_R:
    move.w   (%a2)+,%d1
    lsl.w    %d0,%d1		| shifting

    move.w   (%a3)+,%d3
    lsl.w    %d0,%d3

    move.w   %d3,%d4
    and.w    %d1,%d4
    or.w     %d5,%d4

    and.w    %d4,(%a0)
    and.w    %d4,(%a1)

    not.w    %d4
    and.w    %d4,%d1
    and.w    %d4,%d3

    or.w     %d1,(%a0)
    or.w     %d3,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1

    dbf      %d2,__LoopClipL_GrayClipSprite16_TRANB_R

    movem.l  (%sp)+,%d3-%d5/%a2-%a3
    rts

__ClipXRight_GrayClipSprite16_TRANB_R:
    cmpi.w   #239,%d0
    bhi.s    __End_GrayClipSprite16_TRANB_R		| x > 239

    andi.w   #15,%d0		| shiftx = x & 15

    add.w    %d1,%d1		| %d1 = y*30
    addi.w   #28,%d1		| On va au bout de la ligne
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

    ror.l    %d0,%d5
__LoopClipR_GrayClipSprite16_TRANB_R:
    move.w   (%a2)+,%d1
    lsr.w    %d0,%d1

    move.w   (%a3)+,%d3
    lsr.w    %d0,%d3

    move.w   %d3,%d4
    and.w    %d1,%d4
    or.w     %d5,%d4

    and.w    %d4,(%a0)
    and.w    %d4,(%a1)

    not.w    %d4
    and.w    %d4,%d1
    and.w    %d4,%d3

    or.w     %d1,(%a0)
    or.w     %d3,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1

    dbf      %d2,__LoopClipR_GrayClipSprite16_TRANB_R

    movem.l  (%sp)+,%d3-%d5/%a2-%a3
    rts
