| C prototype: void GrayClipSprite8_ISHADOW2_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),register unsigned char blitmask asm("%d3"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__regparm__(6)));

.data
.globl GrayClipSprite8_ISHADOW2_R
.even

_loop2_GrayClipSprite8_ISHADOW2_R_:
    rol.w    %d1,%d4
    move.w   %d4,%d5
    not.w    %d5

__loop2_GrayClipSprite8_ISHADOW2_R_:
    move.w   (%a0),%d0
    move.w   (%a1),%d1

    move.w   %d0,%d3
    and.w    %d1,%d3
    not.w    %d0
    and.w    %d0,%d1

    and.w    %d5,%d1
    and.w    %d5,%d3

    and.w    %d4,(%a0)
    or.w     %d1,(%a0)

    and.w    %d4,(%a1)
    or.w     %d3,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,__loop2_GrayClipSprite8_ISHADOW2_R_

    movem.l  (%sp)+,%d3-%d5
    rts


GrayClipSprite8_ISHADOW2_R:
    movem.l  %d3-%d5,-(%sp)

    moveq    #-1,%d4
    and.b    %d3,%d4

    subq.w   #1,%d2  | %d2 = h - 1
    move.w   %d1,%d3  | %d3 = y
    bpl.s    __YPositive_GrayClipSprite8_ISHADOW2_R | h > 0 ?

    add.w    %d1,%d2  | %d2 = h + y
    bmi.s    __End_GrayClipSprite8_ISHADOW2_R  | y + h < 0 ?

    moveq.l  #0,%d1  | offsety = 0
    bra.s    __ClipX_GrayClipSprite8_ISHADOW2_R

__YPositive_GrayClipSprite8_ISHADOW2_R:
    subi.w   #127,%d3  | %d3 = y - 128
    bhi.s    __End_GrayClipSprite8_ISHADOW2_R  | y - 128 > 0 ?
    add.w    %d2,%d3  | %d3 = h + y - 128
    bmi.s    __CalcOffset_GrayClipSprite8_ISHADOW2_R | h + y - 128 < 0 ?
    sub.w    %d3,%d2  | h -= h + y -128 (h = y - 128)

__CalcOffset_GrayClipSprite8_ISHADOW2_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1  | %d1 = y*15

__ClipX_GrayClipSprite8_ISHADOW2_R:
    move.w   %d0,%d3  | %d3 = x
    bmi.s    __ClipXLeft_GrayClipSprite8_ISHADOW2_R | x < 0 ?

    cmpi.w   #239-8,%d0
    jbhi     __ClipXRight_GrayClipSprite8_ISHADOW2_R | x > 239-8

    lsr.w    #4,%d3  | %d3 = x/16
    add.w    %d3,%d1  | %d3 = x/16 + y*15
    add.w    %d1,%d1  | %d3 = x/8 + y*30
    adda.w   %d1,%a0  | dest += offset
    adda.w   %d1,%a1

    andi.w   #0xF,%d0
    moveq    #8,%d1
    sub.w    %d0,%d1
    bge.s    _loop2_GrayClipSprite8_ISHADOW2_R_

    neg.w    %d1
    swap     %d4
    ror.l    %d1,%d4
    move.l   %d4,%d5
    not.l    %d5

_loop_GrayClipSprite8_ISHADOW2_R_1:
    move.l   (%a0),%d0
    move.l   (%a1),%d1

    move.l   %d0,%d3
    and.l    %d1,%d3
    not.l    %d0
    and.l    %d0,%d1

    and.l    %d5,%d1
    and.l    %d5,%d3

    and.l    %d4,(%a0)
    or.l     %d1,(%a0)

    and.l    %d4,(%a1)
    or.l     %d3,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,_loop_GrayClipSprite8_ISHADOW2_R_1

__End_GrayClipSprite8_ISHADOW2_R:
    movem.l  (%sp)+,%d3-%d5
    rts

__ClipXLeft_GrayClipSprite8_ISHADOW2_R:
    cmpi.w   #-8,%d0
    bls.s    __End_GrayClipSprite8_ISHADOW2_R  | x <= -8 ?

    neg.w    %d0  | shift = -x
    add.w    %d1,%d1  | %d1 = y*30
    adda.w   %d1,%a0  | dest += offset
    adda.w   %d1,%a1

    rol.w    %d0,%d4

__LoopsClip_GrayClipSprite8_ISHADOW2_R:
    move.b   %d4,%d5
    not.b    %d5

__LoopClipRL_GrayClipSprite8_ISHADOW2_R:
    move.b   (%a0),%d0
    move.b   (%a1),%d1

    move.b   %d0,%d3
    and.b    %d1,%d3
    not.b    %d0
    and.b    %d0,%d1

    and.b    %d5,%d1
    and.b    %d5,%d3

    and.b    %d4,(%a0)
    or.b     %d1,(%a0)

    and.b    %d4,(%a1)
    or.b     %d3,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,__LoopClipRL_GrayClipSprite8_ISHADOW2_R

    movem.l  (%sp)+,%d3-%d5
    rts

__ClipXRight_GrayClipSprite8_ISHADOW2_R:
    cmpi.w   #239,%d0
    bhi.s    __End_GrayClipSprite8_ISHADOW2_R  | x > 239

    andi.w   #7,%d0  | shiftx = x & 7

    add.w    %d1,%d1  | %d1 = y*30
    addi.w   #29,%d1
    adda.w   %d1,%a0
    adda.w   %d1,%a1

    ror.w    %d0,%d4

    bra.s    __LoopsClip_GrayClipSprite8_ISHADOW2_R
