| C prototype: void GraySprite16_SHADOW2_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),register unsigned short blitmask asm("%d3"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__regparm__(6)));
|
| Derived from GraySprite16_SHADOW_R to take a blitmask applied to all lines
| instead of a complete mask. This enables speeding up SHADOW by at least
| one third, this is interesting since SHADOW is the most complex and
| therefore the slowest drawing mode.

.data
.globl GraySprite16_SHADOW2_R
.even

GraySprite16_SHADOW2_R:
    dbf      %d2,__rest_of_GraySprite16_SHADOW2_R__
    rts

__rest_of_GraySprite16_SHADOW2_R__:
    movem.l  %d3-%d5,-(%sp)

    move.w   %d1,%d4 | d4 = y
    lsl.w    #4,%d1 | d1 = 16*y
    sub.w    %d4,%d1 | d1 = 15*y

    move.w   %d0,%d4 | d4 = x
    lsr.w    #4,%d4 | d4 = x/16

    add.w    %d4,%d1 | d1 = 15*y + x/16
    add.w    %d1,%d1 | d1 = 30*y + x/8
    adda.w   %d1,%a0 | a0 += offset
    adda.w   %d1,%a1 | a1 += offset

    andi.w   #0xF,%d0
    moveq    #16,%d1
    sub.w    %d0,%d1

    moveq    #-1,%d4
    and.w    %d3,%d4
    rol.l    %d1,%d4
    move.l   %d4,%d5
    not.l    %d5

    lsr.w    #1,%d2
    bcc.s    __middle_of_loop_GS16_SH2_R__

_loop_GraySprite16_SHADOW2_R_:
    move.l   (%a0),%d0
    move.l   (%a1),%d1

    move.l   %d0,%d3
    not.l    %d3
    or.l     %d1,%d3
    or.l     %d0,%d1
   
    and.l    %d5,%d3
    and.l    %d5,%d1
    
    and.l    %d4,(%a0)
    or.l     %d3,(%a0)

    and.l    %d4,(%a1)
    or.l     %d1,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1
    
__middle_of_loop_GS16_SH2_R__:
    move.l   (%a0),%d0
    move.l   (%a1),%d1

    move.l   %d0,%d3
    not.l    %d3
    or.l     %d1,%d3
    or.l     %d0,%d1

    and.l    %d5,%d3
    and.l    %d5,%d1

    and.l    %d4,(%a0)
    or.l     %d3,(%a0)

    and.l    %d4,(%a1)
    or.l     %d1,(%a1)

    lea      30(%a0),%a0
    lea      30(%a1),%a1

    dbf      %d2,_loop_GraySprite16_SHADOW2_R_
    movem.l  (%sp)+,%d3-%d5
    rts
