| C prototype: void Sprite8Get_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),register void* src asm("%a0"),register unsigned char* dest asm("%a1"));
|
| This routine is faster (about 20%) than the previous C routine, because the
| algorithm was changed.
| An optimization (4 clocks) was made by Ximoon, jackiechan told me about it.

.data
.globl Sprite8Get_R
.even

Sprite8Get_R:
    dbf      %d2,__Rest_of_Sprite8Get_R
    rts

__Rest_of_Sprite8Get_R:
    move.w   %d3,-(%sp)

    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1

    move.w   %d0,%d3
    lsr.w    #4,%d0
    add.w    %d1,%d0
    add.w    %d0,%d0

    adda.w   %d0,%a0

    andi.w   #0xF,%d3
    moveq    #8,%d1
    sub.w    %d3,%d1
    bge.s    _loop_Sprite8Get_R_2

    neg.w    %d1
_loop_Sprite8Get_R_1:
    move.l   (%a0),%d0
    swap     %d0
    rol.l    %d1,%d0
    move.b   %d0,(%a1)+
    lea      30(%a0),%a0
    dbf      %d2,_loop_Sprite8Get_R_1
    
    move.w   (%sp)+,%d3
    rts

_loop_Sprite8Get_R_2:
    move.l   (%a0),%d0
    swap     %d0
    lsr.w    %d1,%d0
    move.b   %d0,(%a1)+
    lea      30(%a0),%a0
    dbf      %d2,_loop_Sprite8Get_R_2

    move.w   (%sp)+,%d3
    rts
