REM @echo off
@echo ======= building extgraph library =======
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Misc\version.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Misc\versionpwd.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Misc\versionnr.c
tigcc -O3 -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Misc\floodfill.c
tigcc -O3 -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Misc\floodfillmf.c
tigcc -O3 -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Misc\floodfill_R.c
tigcc -O3 -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Misc\floodfillmf_R.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Grayutil\graydrawrect2b.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Grayutil\grayinvertrect2b.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Grayutil\graydrawline2b.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Grayutil\grayfastdrawline2b.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Grayutil\grayfastdrawhline2b.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Grayutil\graydrawstr2b.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Grayutil\graydrawstrext2b.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Grayutil\graydrawchar2b.s
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Rect\FastOutlineRect.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Rect\FastOutlineRect_R.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Rect\GrayFastOutlineRect_R.c
tigcc -Os -fomit-frame-pointer -Wall -W -Wwrite-strings --optimize-code --cut-ranges -Wa,--all-relocs -c Rect\GrayFastFillRect_R.c

ar -rv extgraph.a Misc\version.o
ar -rv extgraph.a Misc\versionpwd.o
ar -rv extgraph.a Misc\versionnr.o 
ar -rv extgraph.a Misc\floodfill.o
ar -rv extgraph.a Misc\floodfillmf.o
ar -rv extgraph.a Misc\floodfill_R.o
ar -rv extgraph.a Misc\floodfillmf_R.o
ar -rv extgraph.a Grayutil\graydrawrect2b.o
ar -rv extgraph.a Grayutil\grayinvertrect2b.o
ar -rv extgraph.a Grayutil\graydrawline2b.o
ar -rv extgraph.a Grayutil\grayfastdrawline2b.o
ar -rv extgraph.a Grayutil\grayfastdrawhline2b.o
ar -rv extgraph.a Grayutil\graydrawstr2b.o
ar -rv extgraph.a Grayutil\graydrawstrext2b.o
ar -rv extgraph.a Grayutil\graydrawchar2b.o
ar -rv extgraph.a Rect\FastOutlineRect.o
ar -rv extgraph.a Rect\FastOutlineRect_R.o
ar -rv extgraph.a Rect\GrayFastOutlineRect_R.o
ar -rv extgraph.a Rect\GrayFastFillRect_R.o

copy extgraph.a ..\..\lib
REM del extgraph.a
REM SET ARCHIVE_TOOL=
@echo on
